Index: uspace/lib/c/include/malloc.h
===================================================================
--- uspace/lib/c/include/malloc.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/include/malloc.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -44,5 +44,6 @@
 extern void *memalign(const size_t align, const size_t size)
     __attribute__((malloc));
-extern void *realloc(const void *addr, const size_t size);
+extern void *realloc(const void *addr, const size_t size)
+    __attribute__((warn_unused_result));
 extern void free(const void *addr);
 extern void *heap_check(void);
Index: uspace/lib/c/include/mem.h
===================================================================
--- uspace/lib/c/include/mem.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/include/mem.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -40,9 +40,13 @@
 
 extern void *memset(void *, int, size_t)
+    __attribute__((nonnull(1)))
     ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns");
 extern void *memcpy(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)))
     ATTRIBUTE_OPTIMIZE("-fno-tree-loop-distribute-patterns");
-extern void *memmove(void *, const void *, size_t);
-extern int memcmp(const void *, const void *, size_t);
+extern void *memmove(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)));
+extern int memcmp(const void *, const void *, size_t)
+    __attribute__((nonnull(1, 2)));
 
 #endif
Index: uspace/lib/c/include/task.h
===================================================================
--- uspace/lib/c/include/task.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/include/task.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -60,5 +60,6 @@
 extern int task_spawn(task_id_t *, task_wait_t *, const char *path, int,
     va_list ap);
-extern int task_spawnl(task_id_t *, task_wait_t *, const char *path, ...);
+extern int task_spawnl(task_id_t *, task_wait_t *, const char *path, ...)
+    __attribute__((sentinel));
 
 extern int task_setup_wait(task_id_t, task_wait_t *);
Index: uspace/lib/http/include/http/http.h
===================================================================
--- uspace/lib/http/include/http/http.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/http/include/http/http.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -37,7 +37,7 @@
 #define HTTP_HTTP_H_
 
-#include <net/socket.h>
 #include <adt/list.h>
 #include <inet/addr.h>
+#include <inet/tcp.h>
 
 #include "receive-buffer.h"
@@ -48,7 +48,7 @@
 	inet_addr_t addr;
 
-	bool connected;
-	int conn_sd;
-	
+	tcp_t *tcp;
+	tcp_conn_t *conn;
+
 	size_t buffer_size;
 	receive_buffer_t recv_buffer;
Index: uspace/lib/http/src/http.c
===================================================================
--- uspace/lib/http/src/http.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/http/src/http.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -34,4 +34,5 @@
  */
 
+#include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -39,6 +40,6 @@
 #include <macros.h>
 
-#include <net/socket.h>
 #include <inet/dnsr.h>
+#include <inet/tcp.h>
 
 #include <http/http.h>
@@ -48,5 +49,12 @@
 {
 	http_t *http = client_data;
-	return recv(http->conn_sd, buf, buf_size, 0);
+	size_t nrecv;
+	int rc;
+
+	rc = tcp_conn_recv_wait(http->conn, buf, buf_size, &nrecv);
+	if (rc != EOK)
+		return rc;
+
+	return nrecv;
 }
 
@@ -77,5 +85,5 @@
 int http_connect(http_t *http)
 {
-	if (http->connected)
+	if (http->conn != NULL)
 		return EBUSY;
 	
@@ -95,19 +103,21 @@
 	}
 	
-	struct sockaddr *saddr;
-	socklen_t saddrlen;
+	inet_ep2_t epp;
 	
-	rc = inet_addr_sockaddr(&http->addr, http->port, &saddr, &saddrlen);
-	if (rc != EOK) {
-		assert(rc == ENOMEM);
-		return ENOMEM;
-	}
+	inet_ep2_init(&epp);
+	epp.remote.addr = http->addr;
+	epp.remote.port = http->port;
 	
-	http->conn_sd = socket(saddr->sa_family, SOCK_STREAM, 0);
-	if (http->conn_sd < 0)
-		return http->conn_sd;
+	rc = tcp_create(&http->tcp);
+	if (rc != EOK)
+		return rc;
 	
-	rc = connect(http->conn_sd, saddr, saddrlen);
-	free(saddr);
+	rc = tcp_conn_create(http->tcp, &epp, NULL, NULL, &http->conn);
+	if (rc != EOK)
+		return rc;
+	
+	rc = tcp_conn_wait_connected(http->conn);
+	if (rc != EOK)
+		return rc;
 	
 	return rc;
@@ -116,8 +126,10 @@
 int http_close(http_t *http)
 {
-	if (!http->connected)
+	if (http->conn == NULL)
 		return EINVAL;
 	
-	return closesocket(http->conn_sd);
+	tcp_conn_destroy(http->conn);
+	tcp_destroy(http->tcp);
+	return EOK;
 }
 
Index: uspace/lib/http/src/request.c
===================================================================
--- uspace/lib/http/src/request.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/http/src/request.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -34,4 +34,5 @@
  */
 
+#include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -39,5 +40,5 @@
 #include <macros.h>
 
-#include <net/socket.h>
+#include <inet/tcp.h>
 
 #include <http/http.h>
@@ -149,5 +150,5 @@
 		return rc;
 	
-	rc = send(http->conn_sd, buf, buf_size, 0);
+	rc = tcp_conn_send(http->conn, buf, buf_size);
 	free(buf);
 	
Index: uspace/lib/ieee80211/src/ieee80211.c
===================================================================
--- uspace/lib/ieee80211/src/ieee80211.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/ieee80211/src/ieee80211.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -718,5 +718,5 @@
  *
  */
-ieee80211_dev_t *ieee80211_device_create()
+ieee80211_dev_t *ieee80211_device_create(void)
 {
 	return calloc(1, sizeof(ieee80211_dev_t));
Index: uspace/lib/nettl/Makefile
===================================================================
--- uspace/lib/nettl/Makefile	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/nettl/Makefile	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2015 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+EXTRA_CFLAGS = -Iinclude
+LIBRARY = libnettl
+
+SOURCES = \
+	src/amap.c \
+	src/portrng.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/nettl/include/nettl/amap.h
===================================================================
--- uspace/lib/nettl/include/nettl/amap.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/nettl/include/nettl/amap.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,103 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnettl
+ * @{
+ */
+/**
+ * @file Association map.
+ */
+
+#ifndef LIBNETTL_AMAP_H_
+#define LIBNETTL_AMAP_H_
+
+#include <adt/list.h>
+#include <inet/endpoint.h>
+#include <nettl/portrng.h>
+#include <loc.h>
+
+/** Port range for (remote endpoint, local address) */
+typedef struct {
+	/** Link to amap_t.repla */
+	link_t lamap;
+	/** Remote endpoint */
+	inet_ep_t rep;
+	/* Local address */
+	inet_addr_t laddr;
+	/** Port range */
+	portrng_t *portrng;
+} amap_repla_t;
+
+/** Port range for local address */
+typedef struct {
+	/** Link to amap_t.laddr */
+	link_t lamap;
+	/** Local address */
+	inet_addr_t laddr;
+	/** Port range */
+	portrng_t *portrng;
+} amap_laddr_t;
+
+/** Port range for local link */
+typedef struct {
+	/** Link to amap_t.llink */
+	link_t lamap;
+	/** Local link ID */
+	service_id_t llink;
+	/** Port range */
+	portrng_t *portrng;
+} amap_llink_t;
+
+/** Association map */
+typedef struct {
+	/** Remote endpoint, local address */
+	list_t repla; /* of amap_repla_t */
+	/** Local addresses */
+	list_t laddr; /* of amap_laddr_t */
+	/** Local links */
+	list_t llink; /* of amap_llink_t */
+	/** Nothing specified (listen on all local adresses) */
+	portrng_t *unspec;
+} amap_t;
+
+typedef enum {
+	/** Allow specifying port number from system range */
+	af_allow_system = 0x1
+} amap_flags_t;
+
+extern int amap_create(amap_t **);
+extern void amap_destroy(amap_t *);
+extern int amap_insert(amap_t *, inet_ep2_t *, void *, amap_flags_t,
+    inet_ep2_t *);
+extern void amap_remove(amap_t *, inet_ep2_t *);
+extern int amap_find_match(amap_t *, inet_ep2_t *, void **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/nettl/include/nettl/portrng.h
===================================================================
--- uspace/lib/nettl/include/nettl/portrng.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/nettl/include/nettl/portrng.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,71 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnettl
+ * @{
+ */
+/**
+ * @file Port range allocator.
+ */
+
+#ifndef LIBNETTL_PORTRNG_H_
+#define LIBNETTL_PORTRNG_H_
+
+#include <stdbool.h>
+#include <stdint.h>
+
+/** Allocated port */
+typedef struct {
+	/** Link to portrng_t.used */
+	link_t lprng;
+	/** Port number */
+	uint16_t pn;
+	/** User argument */
+	void *arg;
+} portrng_port_t;
+
+typedef struct {
+	list_t used; /* of portrng_port_t */
+} portrng_t;
+
+typedef enum {
+	pf_allow_system = 0x1
+} portrng_flags_t;
+
+extern int portrng_create(portrng_t **);
+extern void portrng_destroy(portrng_t *);
+extern int portrng_alloc(portrng_t *, uint16_t, void *,
+    portrng_flags_t, uint16_t *);
+extern int portrng_find_port(portrng_t *, uint16_t, void **);
+extern void portrng_free_port(portrng_t *, uint16_t);
+extern bool portrng_empty(portrng_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/nettl/src/amap.c
===================================================================
--- uspace/lib/nettl/src/amap.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
+++ uspace/lib/nettl/src/amap.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -0,0 +1,572 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnettl
+ * @{
+ */
+
+/**
+ * @file Association map
+ *
+ * Manages allocations of endpoints / endpoint pairs (corresponding to
+ * UDP associations, TCP listeners and TCP connections)
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <inet/addr.h>
+#include <inet/inet.h>
+#include <io/log.h>
+#include <nettl/amap.h>
+#include <stdint.h>
+#include <stdlib.h>
+
+int amap_create(amap_t **rmap)
+{
+	amap_t *map;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_create()");
+
+	map = calloc(1, sizeof(amap_t));
+	if (map == NULL)
+		return ENOMEM;
+
+	rc = portrng_create(&map->unspec);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		free(map);
+		return ENOMEM;
+	}
+
+	list_initialize(&map->repla);
+	list_initialize(&map->laddr);
+	list_initialize(&map->llink);
+
+	*rmap = map;
+	return EOK;
+}
+
+void amap_destroy(amap_t *map)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_destroy()");
+	free(map);
+}
+
+/** Find exact repla */
+static int amap_repla_find(amap_t *map, inet_ep_t *rep, inet_addr_t *la,
+    amap_repla_t **rrepla)
+{
+	char *sraddr, *sladdr;
+
+	(void) inet_addr_format(&rep->addr, &sraddr);
+	(void) inet_addr_format(la, &sladdr);
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_repla_find(): rep=(%s,%" PRIu16
+	    ") la=%s", sraddr, rep->port, sladdr);
+	free(sraddr);
+	free(sladdr);
+
+	list_foreach(map->repla, lamap, amap_repla_t, repla) {
+		(void) inet_addr_format(&repla->rep.addr, &sraddr);
+		(void) inet_addr_format(&repla->laddr, &sladdr);
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_repla_find(): "
+		    "compare to rep=(%s, %" PRIu16 ") la=%s",
+		    sraddr, repla->rep.port, sladdr);
+		free(sraddr);
+		free(sladdr);
+		if (inet_addr_compare(&repla->rep.addr, &rep->addr) &&
+		    repla->rep.port == rep->port &&
+		    inet_addr_compare(&repla->laddr, la)) {
+			*rrepla = repla;
+			return EOK;
+		}
+	}
+
+	*rrepla = NULL;
+	return ENOENT;
+}
+
+static int amap_repla_insert(amap_t *map, inet_ep_t *rep, inet_addr_t *la,
+    amap_repla_t **rrepla)
+{
+	amap_repla_t *repla;
+	int rc;
+
+	repla = calloc(1, sizeof(amap_repla_t));
+	if (repla == NULL) {
+		*rrepla = NULL;
+		return ENOMEM;
+	}
+
+	rc = portrng_create(&repla->portrng);
+	if (rc != EOK) {
+		free(repla);
+		return ENOMEM;
+	}
+
+	repla->rep = *rep;
+	repla->laddr = *la;
+	list_append(&repla->lamap, &map->repla);
+
+	*rrepla = repla;
+	return EOK;
+}
+
+static void amap_repla_remove(amap_t *map, amap_repla_t *repla)
+{
+	list_remove(&repla->lamap);
+	portrng_destroy(repla->portrng);
+	free(repla);
+}
+
+/** Find exact laddr */
+static int amap_laddr_find(amap_t *map, inet_addr_t *addr,
+    amap_laddr_t **rladdr)
+{
+	list_foreach(map->laddr, lamap, amap_laddr_t, laddr) {
+		if (inet_addr_compare(&laddr->laddr, addr)) {
+			*rladdr = laddr;
+			return EOK;
+		}
+	}
+
+	*rladdr = NULL;
+	return ENOENT;
+}
+
+static int amap_laddr_insert(amap_t *map, inet_addr_t *addr,
+    amap_laddr_t **rladdr)
+{
+	amap_laddr_t *laddr;
+	int rc;
+
+	laddr = calloc(1, sizeof(amap_laddr_t));
+	if (laddr == NULL) {
+		*rladdr = NULL;
+		return ENOMEM;
+	}
+
+	rc = portrng_create(&laddr->portrng);
+	if (rc != EOK) {
+		free(laddr);
+		return ENOMEM;
+	}
+
+	laddr->laddr = *addr;
+	list_append(&laddr->lamap, &map->laddr);
+
+	*rladdr = laddr;
+	return EOK;
+}
+
+static void amap_laddr_remove(amap_t *map, amap_laddr_t *laddr)
+{
+	list_remove(&laddr->lamap);
+	portrng_destroy(laddr->portrng);
+	free(laddr);
+}
+
+/** Find exact llink */
+static int amap_llink_find(amap_t *map, sysarg_t link_id,
+    amap_llink_t **rllink)
+{
+	list_foreach(map->llink, lamap, amap_llink_t, llink) {
+		if (llink->llink == link_id) {
+			*rllink = llink;
+			return EOK;
+		}
+	}
+
+	*rllink = NULL;
+	return ENOENT;
+}
+
+static int amap_llink_insert(amap_t *map, sysarg_t link_id,
+    amap_llink_t **rllink)
+{
+	amap_llink_t *llink;
+	int rc;
+
+	llink = calloc(1, sizeof(amap_llink_t));
+	if (llink == NULL) {
+		*rllink = NULL;
+		return ENOMEM;
+	}
+
+	rc = portrng_create(&llink->portrng);
+	if (rc != EOK) {
+		free(llink);
+		return ENOMEM;
+	}
+
+	llink->llink = link_id;
+	list_append(&llink->lamap, &map->llink);
+
+	*rllink = llink;
+	return EOK;
+}
+
+static void amap_llink_remove(amap_t *map, amap_llink_t *llink)
+{
+	list_remove(&llink->lamap);
+	portrng_destroy(llink->portrng);
+	free(llink);
+}
+
+static int amap_insert_repla(amap_t *map, inet_ep2_t *epp, void *arg,
+    amap_flags_t flags, inet_ep2_t *aepp)
+{
+	amap_repla_t *repla;
+	inet_ep2_t mepp;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert_repla()");
+
+	rc = amap_repla_find(map, &epp->remote, &epp->local.addr, &repla);
+	if (rc != EOK) {
+		/* New repla */
+		rc = amap_repla_insert(map, &epp->remote, &epp->local.addr,
+		    &repla);
+		if (rc != EOK) {
+			assert(rc == ENOMEM);
+			return rc;
+		}
+	}
+
+	mepp = *epp;
+
+	rc = portrng_alloc(repla->portrng, epp->local.port, arg, flags,
+	    &mepp.local.port);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	*aepp = mepp;
+	return EOK;
+}
+
+static int amap_insert_laddr(amap_t *map, inet_ep2_t *epp, void *arg,
+    amap_flags_t flags, inet_ep2_t *aepp)
+{
+	amap_laddr_t *laddr;
+	inet_ep2_t mepp;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert_laddr()");
+
+	rc = amap_laddr_find(map, &epp->local.addr, &laddr);
+	if (rc != EOK) {
+		/* New laddr */
+		rc = amap_laddr_insert(map, &epp->local.addr, &laddr);
+		if (rc != EOK) {
+			assert(rc == ENOMEM);
+			return rc;
+		}
+	}
+
+	mepp = *epp;
+
+	rc = portrng_alloc(laddr->portrng, epp->local.port, arg, flags,
+	    &mepp.local.port);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	*aepp = mepp;
+	return EOK;
+}
+
+static int amap_insert_llink(amap_t *map, inet_ep2_t *epp, void *arg,
+    amap_flags_t flags, inet_ep2_t *aepp)
+{
+	amap_llink_t *llink;
+	inet_ep2_t mepp;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert_llink()");
+
+	rc = amap_llink_find(map, epp->local_link, &llink);
+	if (rc != EOK) {
+		/* New llink */
+		rc = amap_llink_insert(map, epp->local_link, &llink);
+		if (rc != EOK) {
+			assert(rc == ENOMEM);
+			return rc;
+		}
+	}
+
+	mepp = *epp;
+
+	rc = portrng_alloc(llink->portrng, epp->local.port, arg, flags,
+	    &mepp.local.port);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	*aepp = mepp;
+	return EOK;
+}
+
+static int amap_insert_unspec(amap_t *map, inet_ep2_t *epp, void *arg,
+    amap_flags_t flags, inet_ep2_t *aepp)
+{
+	inet_ep2_t mepp;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert_unspec()");
+	mepp = *epp;
+
+	rc = portrng_alloc(map->unspec, epp->local.port, arg, flags,
+	    &mepp.local.port);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	*aepp = mepp;
+	return EOK;
+}
+
+/** Insert endpoint pair into map.
+ *
+ * If local endpoint is not fully specified, it is filled in (determine
+ * source address, allocate port number). Checks for conflicting endpoint pair.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair, possibly with local port inet_port_any
+ * @param arg arg User value
+ * @param flags Flags
+ * @param aepp Place to store actual endpoint pair, possibly with allocated port
+ *
+ * @return EOK on success, EEXISTS if conflicting epp exists,
+ *         ENOMEM if out of memory
+ */
+int amap_insert(amap_t *map, inet_ep2_t *epp, void *arg, amap_flags_t flags,
+    inet_ep2_t *aepp)
+{
+	bool raddr, rport, laddr, llink;
+	inet_ep2_t mepp;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert()");
+
+	mepp = *epp;
+
+	/* Fill in local address? */
+	if (!inet_addr_is_any(&epp->remote.addr) &&
+	    inet_addr_is_any(&epp->local.addr)) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert: "
+		    "determine local address");
+		rc = inet_get_srcaddr(&epp->remote.addr, 0, &mepp.local.addr);
+		if (rc != EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert: "
+			    "cannot determine local address");
+			return rc;
+		}
+	} else {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert: "
+		    "local address specified or remote address not specified");
+	}
+
+	raddr = !inet_addr_is_any(&mepp.remote.addr);
+	rport = mepp.remote.port != inet_port_any;
+	laddr = !inet_addr_is_any(&mepp.local.addr);
+	llink = mepp.local_link != 0;
+
+	if (raddr && rport && laddr && !llink) {
+		return amap_insert_repla(map, &mepp, arg, flags, aepp);
+	} else if (!raddr && !rport && laddr && !llink) {
+		return amap_insert_laddr(map, &mepp, arg, flags, aepp);
+	} else if (!raddr && !rport && !laddr && llink) {
+		return amap_insert_llink(map, &mepp, arg, flags, aepp);
+	} else if (!raddr && !rport && !laddr && !llink) {
+		return amap_insert_unspec(map, &mepp, arg, flags, aepp);
+	} else {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert: invalid "
+		    "combination of raddr=%d rport=%d laddr=%d llink=%d",
+		    raddr, rport, laddr, llink);
+		return EINVAL;
+	}
+
+	return EOK;
+}
+
+static void amap_remove_repla(amap_t *map, inet_ep2_t *epp)
+{
+	amap_repla_t *repla;
+	int rc;
+
+	rc = amap_repla_find(map, &epp->remote, &epp->local.addr, &repla);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_remove_repla: not found");
+		return;
+	}
+
+	portrng_free_port(repla->portrng, epp->local.port);
+
+	if (portrng_empty(repla->portrng))
+		amap_repla_remove(map, repla);
+}
+
+static void amap_remove_laddr(amap_t *map, inet_ep2_t *epp)
+{
+	amap_laddr_t *laddr;
+	int rc;
+
+	rc = amap_laddr_find(map, &epp->local.addr, &laddr);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_remove_laddr: not found");
+		return;
+	}
+
+	portrng_free_port(laddr->portrng, epp->local.port);
+
+	if (portrng_empty(laddr->portrng))
+		amap_laddr_remove(map, laddr);
+}
+
+static void amap_remove_llink(amap_t *map, inet_ep2_t *epp)
+{
+	amap_llink_t *llink;
+	int rc;
+
+	rc = amap_llink_find(map, epp->local_link, &llink);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_remove_llink: not found");
+		return;
+	}
+
+	portrng_free_port(llink->portrng, epp->local.port);
+
+	if (portrng_empty(llink->portrng))
+		amap_llink_remove(map, llink);
+}
+
+static void amap_remove_unspec(amap_t *map, inet_ep2_t *epp)
+{
+	portrng_free_port(map->unspec, epp->local.port);
+}
+
+void amap_remove(amap_t *map, inet_ep2_t *epp)
+{
+	bool raddr, rport, laddr, llink;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_remove()");
+
+	raddr = !inet_addr_is_any(&epp->remote.addr);
+	rport = epp->remote.port != inet_port_any;
+	laddr = !inet_addr_is_any(&epp->local.addr);
+	llink = epp->local_link != 0;
+
+	if (raddr && rport && laddr && !llink) {
+		amap_remove_repla(map, epp);
+	} else if (!raddr && !rport && laddr && !llink) {
+		amap_remove_laddr(map, epp);
+	} else if (!raddr && !rport && !laddr && llink) {
+		amap_remove_llink(map, epp);
+	} else if (!raddr && !rport && !laddr && !llink) {
+		amap_remove_unspec(map, epp);
+	} else {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_remove: invalid "
+		    "combination of raddr=%d rport=%d laddr=%d llink=%d",
+		    raddr, rport, laddr, llink);
+		return;
+	}
+}
+
+/** Find association matching an endpoint pair.
+ *
+ * Used to find which association to deliver a datagram to.
+ *
+ * @param map	Association map
+ * @param epp	Endpoint pair
+ * @param rarg	Place to store user argument for the matching association.
+ *
+ * @return	EOK on success, ENOENT if not found.
+ */
+int amap_find_match(amap_t *map, inet_ep2_t *epp, void **rarg)
+{
+	int rc;
+	amap_repla_t *repla;
+	amap_laddr_t *laddr;
+	amap_llink_t *llink;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_find_match(llink=%zu)",
+	    epp->local_link);
+
+	/* Remode endpoint, local address */
+	rc = amap_repla_find(map, &epp->remote, &epp->local.addr, &repla);
+	if (rc == EOK) {
+		rc = portrng_find_port(repla->portrng, epp->local.port,
+		    rarg);
+		if (rc == EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "Matched repla / "
+			    "port %" PRIu16, epp->local.port);
+			return EOK;
+		}
+	}
+
+	/* Local address */
+	rc = amap_laddr_find(map, &epp->local.addr, &laddr);
+	if (rc == EOK) {
+		rc = portrng_find_port(laddr->portrng, epp->local.port,
+		    rarg);
+		if (rc == EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "Matched laddr / "
+			    "port %" PRIu16, epp->local.port);
+			return EOK;
+		}
+	}
+
+	/* Local link */
+	rc = amap_llink_find(map, epp->local_link, &llink);
+	if (epp->local_link != 0 && rc == EOK) {
+		rc = portrng_find_port(llink->portrng, epp->local.port,
+		    rarg);
+		if (rc == EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "Matched llink / "
+			    "port %" PRIu16, epp->local.port);
+			return EOK;
+		}
+	}
+
+	/* Unspecified */
+	rc = portrng_find_port(map->unspec, epp->local.port, rarg);
+	if (rc == EOK) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "Matched unspec / port %" PRIu16,
+		    epp->local.port);
+		return EOK;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "No match.");
+	return ENOENT;
+}
+
+/**
+ * @}
+ */
